{-  Copyright 2010 Dominique Devriese

    This file is part of the grammar-combinators library.

    The grammar-combinators library is free software: you can
    redistribute it and/or modify it under the terms of the GNU
    Lesser General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at
    your option) any later version.

    Foobar is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with Foobar. If not, see
    <http://www.gnu.org/licenses/>.
-}
{-# LANGUAGE TemplateHaskell #-}
{-# LANGUAGE FlexibleContexts #-}

module Text.GrammarCombinators.TH.Base where

import Text.GrammarCombinators.Base

import Language.Haskell.TH.Syntax

import Data.Set
import qualified Data.Set as Set

instance (Lift v) => Lift (Set v) where
  lift s = [| Set.fromDistinctAscList $(lift $ toAscList s) |]


instance Lift v => Lift (K0 v ix) where
  lift (K0 v) = [| K0 $(lift v) |]
  
instance (Lift (v (supIxT ix))) =>
         Lift (SubVal supIxT v ix) where
  lift (MkSubVal v) = [| MkSubVal $(lift v) |]
